﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using HeuristicLab.Core.Views;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views;
using HeuristicLab.MainForm;
using System.Diagnostics;
using System.IO;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;


namespace HeuristicLab.Problems.Robocode
{
    [View("CodeNode View")]
    [Content(typeof(CodeNode), IsDefaultView = true)]
    public partial class CodeNodeView : NamedItemView
    {
        public CodeNode Content
        {
            get { return (CodeNode)base.Content; }
            set { base.Content = value; }
        }

        public CodeNodeView() : base()
        {
            InitializeComponent();
            //this.prefixCode.Text = Content.Prefix;
            //this.suffixCode.Text = Content.Suffix;
        }

        protected override void OnContentChanged()
        {
            base.OnContentChanged();
            if (Content == null)
            {
                this.prefixCode.Text = "";
                this.suffixCode.Text = "";
            }
            else
            {
                this.prefixCode.Text = Content.Prefix;
                this.suffixCode.Text = Content.Suffix;
                //Content.Prefix = this.prefixCode.Text;
                //Content.Suffix = this.suffixCode.Text;
            }
        }

        private void prefixCode_Leave(object sender, EventArgs e)
        {
            Content.Prefix = this.prefixCode.Text;
        }

        private void suffixCode_Leave(object sender, EventArgs e)
        {
            Content.Suffix = this.suffixCode.Text;
        }
    }
}
