﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode
{
    [StorableClass]
    public class Equal : CodeNode
    {
        public override int MinimumArity { get { return 0; } }
        public override int MaximumArity { get { return 0; } }

        [Storable]
        public override string Prefix { get; set; }

        [Storable]
        public override string Suffix { get; set; }

        [StorableConstructor]
        private Equal(bool deserializing) : base(deserializing) { }
        private Equal(Equal original, Cloner cloner)
            : base(original, cloner)
        {
            this.Prefix = "==";
            this.Suffix = "";
        }

        public Equal()
            : base("Equal", "Equal comparator.")
        {
            this.Prefix = "==";
            this.Suffix = "";
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new Equal(this, cloner);
        }

        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
        {
            return this.Prefix + " " + this.Suffix;
        }
    }
}
